GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | List of all members
Log::LALogger Class Referenceabstract

Learning Agent logger class that will be called during LearningAgent executions. More...

`#include <laLogger.h>`

Inheritance diagram for Log::LALogger:

## Public Member Functions
| LALogger (Learn::LearningAgent &la, std::ostream &out=std::cout)
| Constructor defining a given output and setting start and checkpoint as now. Default output is cout.
void | chronoFromNow ()
| Updates checkpoint to now.
virtual void | logHeader ()=0
| Logs the header (e.g. column names) of this logger.
virtual void | logNewGeneration (uint64_t &generationNumber)=0
| Method called by the LearningAgent at the start of a generation.
virtual void | logAfterPopulateTPG ()=0
| Method called by the Learning Agent right after PopulateTPG is done.
virtual void | logAfterEvaluate (std::multimap< std::shared_ptr< Learn::EvaluationResult >, const TPG::TPGVertex * > &results)=0
| Method called by the Learning Agent right after the evaluation is done.
virtual void | logAfterDecimate ()=0
| Method called by the Learning Agent right after the decimation is done.
virtual void | logAfterValidate (std::multimap< std::shared_ptr< Learn::EvaluationResult >, const TPG::TPGVertex * > &results)=0
| Method called by the Learning Agent right after the validation is done.
virtual void | logEndOfTraining ()=0
| Method called by the Learning Agent when the training is done.
Public Member Functions inherited from Log::Logger
| Logger (std::ostream &out=std::cout)
| Constructor initializing a specific output. Default is cout.
virtual | ~Logger ()=default
| Virtual default destructor for polyphormism support.
Logger | operator<< (std::ostream &(*manip)(std::ostream &))
| << operator to manipulate stream and enter stream-specific elements (like std::endl).
template<typename T >
Logger | operator<< (const T &val)
| << operator allowing to log elements that ostream actually accepts (char, int...).

## Public Attributes
bool | doValidation = false
bool | useUtility = false

## Protected Member Functions
double | getDurationFrom (const std::chrono::time_point< std::chrono::system_clock, std::chrono::nanoseconds > &begin) const
| Computes the duration from a given time to now.
std::chrono::time_point< std::chrono::system_clock, std::chrono::nanoseconds > | getTime () const
| Gets the current time value, for example to set checkpoint.

## Protected Attributes
std::shared_ptr< std::chrono::time_point< std::chrono::system_clock, std::chrono::nanoseconds > > const | start
std::shared_ptr< std::chrono::time_point< std::chrono::system_clock, std::chrono::nanoseconds > > | checkpoint
double | mutationTime = 0
double | evalTime = 0
double | validTime = 0
double | decimationTime = 0
Learn::LearningAgent & | learningAgent
| LearningAgent logged by the LALogger.

## Detailed Description

Learning Agent logger class that will be called during LearningAgent executions.

The idea of this class' methods is close to the idea of a callback. Each time the learning process does something, a specific method could be called by the LearningAgent. The many possible implementations of these methods allows the user to log whatever he wants.

## Constructor & Destructor Documentation

## ◆ LALogger()

Log::LALogger::LALogger | ( | Learn::LearningAgent & | la,
|  | std::ostream & | out = std::cout )
| explicit

Constructor defining a given output and setting start and checkpoint as now. Default output is cout.

The constructed LALogger will add itself automatically to the Loggers of the given LearningAgent.

Parameters

  [in] | la | The LearningAgent which will be logged by this LALogger.
  [in] | out | The output stream the logger will send elements to.

## Member Function Documentation

## ◆ getDurationFrom()

double Log::LALogger::getDurationFrom | ( | const std::chrono::time_point< std::chrono::system_clock, std::chrono::nanoseconds > & | begin | ) | const
| protected

Computes the duration from a given time to now.

Parameters

  [in] | begin | Time from which the durations will be computed

Returns
  The duration from begin to now in seconds.

Copyright or © or Copr. IETR/INSA - Rennes (2020) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2020) Pierre-Yves Le Rolland-Raumer plero.nosp@m.lla@.nosp@m.insa-.nosp@m.renn.nosp@m.es.fr (2020)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

## ◆ getTime()

std::chrono::time_point< std::chrono::system_clock, std::chrono::nanoseconds > Log::LALogger::getTime | ( |  | ) | const
| protected

Gets the current time value, for example to set checkpoint.

Returns
  The current time value.

## ◆ logAfterDecimate()

virtual void Log::LALogger::logAfterDecimate | ( |  | ) |
| pure virtual

Method called by the Learning Agent right after the decimation is done.

Implemented in Log::CycleDetectionLALogger, Log::LABasicLogger, and Log::LAPolicyStatsLogger.

## ◆ logAfterEvaluate()

virtual void Log::LALogger::logAfterEvaluate | ( | std::multimap< std::shared_ptr< Learn::EvaluationResult >, const TPG::TPGVertex * > & | results | ) |
| pure virtual

Method called by the Learning Agent right after the evaluation is done.

Parameters

  [in] | results | scores of the evaluation.

Implemented in Log::CycleDetectionLALogger, Log::LABasicLogger, and Log::LAPolicyStatsLogger.

## ◆ logAfterPopulateTPG()

virtual void Log::LALogger::logAfterPopulateTPG | ( |  | ) |
| pure virtual

Method called by the Learning Agent right after PopulateTPG is done.

Implemented in Log::CycleDetectionLALogger, Log::LABasicLogger, and Log::LAPolicyStatsLogger.

## ◆ logAfterValidate()

virtual void Log::LALogger::logAfterValidate | ( | std::multimap< std::shared_ptr< Learn::EvaluationResult >, const TPG::TPGVertex * > & | results | ) |
| pure virtual

Method called by the Learning Agent right after the validation is done.

Parameters

  [in] | results | scores of the validation.

Implemented in Log::CycleDetectionLALogger, Log::LABasicLogger, and Log::LAPolicyStatsLogger.

## ◆ logEndOfTraining()

virtual void Log::LALogger::logEndOfTraining | ( |  | ) |
| pure virtual

Method called by the Learning Agent when the training is done.

Implemented in Log::CycleDetectionLALogger, Log::LABasicLogger, and Log::LAPolicyStatsLogger.

## ◆ logHeader()

virtual void Log::LALogger::logHeader | ( |  | ) |
| pure virtual

Logs the header (e.g. column names) of this logger.

Implemented in Log::CycleDetectionLALogger, Log::LABasicLogger, and Log::LAPolicyStatsLogger.

## ◆ logNewGeneration()

virtual void Log::LALogger::logNewGeneration | ( | uint64_t & | generationNumber | ) |
| pure virtual

Method called by the LearningAgent at the start of a generation.

Parameters

  [in] | generationNumber | The number of the current generation.

Implemented in Log::CycleDetectionLALogger, Log::LABasicLogger, and Log::LAPolicyStatsLogger.

## Member Data Documentation

## ◆ checkpoint

std::shared_ptr<std::chrono::time_point<std::chrono::system_clock, std::chrono::nanoseconds> > Log::LALogger::checkpoint
| protected

Keeps a given time to be able to show durations from that moment, e.g. to know the duration of the eval.

## ◆ decimationTime

double Log::LALogger::decimationTime = 0
| protected

Keeps the duration of the decimation to be able to log it some time after it is computed.

## ◆ doValidation

bool Log::LALogger::doValidation = false

Boolean telling the logger if the training will make a validation

## ◆ evalTime

double Log::LALogger::evalTime = 0
| protected

Keeps the duration of the evaluation to be able to log it some time after it is computed.

## ◆ mutationTime

double Log::LALogger::mutationTime = 0
| protected

Keeps the duration of the mutation to be able to log it some time after it is computed.

## ◆ start

std::shared_ptr<std::chrono::time_point< std::chrono::system_clock, std::chrono::nanoseconds> > const Log::LALogger::start
| protected

Keeps the time of logger declaration to be able to show durations from the beginning of the learning.

## ◆ useUtility

bool Log::LALogger::useUtility = false

Boolean telling the logger if the LearningEnvironment returns also a utility with the score

## ◆ validTime

double Log::LALogger::validTime = 0
| protected

Keeps the duration of the validation to be able to log it some time after it is computed.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/log/laLogger.h
- D:/a/gegelati/gegelati/gegelatilib/src/log/laLogger.cpp